/*
 * Simulator of MCS51 (option.h)
 *
 * Copyright (C) 1997,97 Drotos Daniel, Talker Bt.
 * 
 * To contact author send email to drdani@mazsola.iit.uni-miskolc.hu
 *
 */

/* This file is part of MCS51 simulator: s51.

S51 is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

S51 is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with S51; see the file COPYING.  If not, write to the Free
Software Foundation, 59 Temple Place - Suite 330, Boston, MA
02111-1307, USA. */
/*@1@*/

#ifndef OPTION_HEADER
#define OPTION_HEADER

#include "ddconfig.h"

#include <stdio.h>

#include "pobj.h"
#include "stypes.h"


class option_base: public TObject
{
protected:
  void *option;
public:
  char *id;
  char *help;

public:
  option_base(void *opt, char *Iid, char *Ihelp);
  virtual ~option_base(void);

  virtual void print(FILE *f)= 0;

  virtual bool get_value(void)= 0;

  virtual void set_value(bool)= 0;
  virtual void set_value(char *s)= 0;
};


class option_bool: public option_base
{
public:
  option_bool(bool *opt, char *Iid, char *Ihelp);

  virtual void print(FILE *f);
  virtual bool get_value(void);
  virtual void set_value(bool);
  virtual void set_value(char *s);
};


#endif

/* End of option.h */
